<?php

use WSCOMUN\WSComunFClient;

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyGDE2 		= WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://instrumental-pre.gva.es/pai_bus_ins/GDE/GDEService_v2_00?wsdl'	// Instrumentales
		//$keyGDE2 => 		'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/GDE/GdeWSService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


//Parametros de invocacin generales
$codApp = 'RABA';

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_GDE2, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);

	$respuestaGDE2 = $clienteSIRCA->buscarDocCriterioPaginadoGDE2($codApp, 100, 1, null, null, 'OR',
		array(
			array(
				'tipo' => 'CRITERIO_ASPECTO',
				'nombre' => 'gdg:doc_gustavo',
				'paramNombre' => 'gdg:doc_u_s_id_expediente',
				'paramTipo' => 'CADENA',
				'paramValor' => '0',
				'operador' => 'OPERADOR_IGUAL'
			), array(
				'tipo' => 'CRITERIO_ASPECTO',
				'nombre' => 'gdg:doc_gustavo',
				'paramNombre' => 'gdg:doc_u_s_id_expediente',
				'paramTipo' => 'FECHA',
				'paramValor' => new DateTime('2015-05-11 16:17:17'),
				'operador' => 'OPERADOR_MENOR'
			)
		));

	echo('<pre>');print_r($respuestaGDE2);echo('</pre>');
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>