<?php

use WSCOMUN\WSComunFClient;
use WSCOMUN\WSComunPAIException;

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../../include/WSComunFClient.php';
$keyLOGIN = WSComunFClient::KEYCLIENTE_GVLOGIN;


/* Array de URIs con los WSDLs descriptivos del servicio */
$v_wsdl = array
(
	$keyLOGIN => 'https://innovacion-pre.gva.es/pai_bus_inno/GVLOGIN/SSOService_v1_00?wsdl'
	//$keyLOGIN => 'https://innovacion.gva.es/pai_bus_inno/GVLOGIN/SSOService_v1_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_opciones = array
(
		//'certFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.crt'),
		//'keyFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase' 			=> null,
		'enableWSSecurity' 		=> false, //Innovacion
		'enableTrazabilidadPAI' => true,
		'idApp' 				=> 'WSCOMUN'
);


//Es necesario tener un tokenSSO valido
//Se puede forzar un error de PAI cambiado 'idApp' por 'xxx' (por ejemplo)

//Parametros de invocacin generales
$codApp = 'WSComun';
$tokenSSO = null;
$ip = WSComunFClient::getClientIP();
$agent = (isset($_SERVER['HTTP_X_USER_AGENT']))?$_SERVER['HTTP_X_USER_AGENT']:$_SERVER['HTTP_USER_AGENT'];

// Recepcion externa del token
if (isset($_COOKIE['gvlogin_login_GVLOGIN_COOKIE']))
{
	$tokenSSO = $_COOKIE['gvlogin_login_GVLOGIN_COOKIE'];
}
else if (isset($_REQUEST['tokenSSO']))
{
	$tokenSSO = $_REQUEST['tokenSSO'];
}

if (isset($_REQUEST['codApp']))
{
	$codApp = $_REQUEST['codApp'];
}


// Cabecera de links y acceso rapido
require_once 'libOpts.php';
showLinks($tokenSSO);


print("Prueba de LOGIN: obtenerContexto($codApp, $tokenSSO, $ip, $agent)<br>\n");
try
{
	set_time_limit(40);
	$clienteWS = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_GVLOGIN, $v_wsdl, $v_opciones);
	$clienteWS->setDebugMode(true);

	$oResp = $clienteWS->obtenerContexto($codApp, $tokenSSO, $ip, $agent);

	// Tratamiento de la respuesta
	if ($oResp->getResultado() == true) {
		print("\n<br>Resultado de la llamada: " . ($oResp->getResultado() ? "True" : "False") . "<br>\n<br>\n");

		// Visor detallado de la respuesta
		print("dni: " . $oResp->getDni() . "<br>\n");
		print("nombre: " . $oResp->getNombre() . "<br>\n");
		print("apellido1: " . $oResp->getApellido1() . "<br>\n");
		print("apellido2: " . $oResp->getApellido2() . "<br>\n");
		print("mail: " . $oResp->getMail() . "<br>\n");

		print("<br>\nInfoAmpliada:<br>\n");
		for ($iParam=0; $iParam < $oResp->sizeOfInfoAmpliada(); $iParam++) {
			$oParam = $oResp->getInfoAmpliada($iParam);
			print("  - InfoAmpliada[$iParam]: {$oParam->getNombre()} - {$oParam->getValor()}<br>\n");
		}

		print("<br>\nRoles:<br>\n");
		for ($iRol=0; $iRol < $oResp->sizeOfRoles(); $iRol++) {
			$oRol = $oResp->getRoles($iRol);
			print("  - Rol[$iRol]: {$oRol->getCodigo()}<br>\n");

			if ($oRol->hasParametro()) {
				for ($iParam=0; $iParam < $oRol->sizeOfParametro(); $iParam++) {
					$oParam = $oRol->getParametro($iParam);
					print("     -- Param[$iParam]: {$oParam->getNombre()} - {$oParam->getValor()}<br>\n");
				}
			}
		}

		var_dump($oResp);


	} else {
		print("\n<br>Resultado de la llamada: " . ($oResp->getResultado() ? "True" : "False") . "<br>\n<br>\n");

		// Informar error
		$oError = $oResp->getError();
		print("Error: {$oError}<br>\n");

		print("  - CODIGO: " . $oError->getCodigoError());print("\n<br/>");
		print("  - MENSAJE: " . $oError->getMensajeError());print("\n<br/>");

		var_dump($oResp);die;
	}

}
catch (WSComunPAIException $e)
{
	print("\n<br/>Excepcion PAI: \n<br/>");
	print("  - ERROR: " . $e);print("\n<br/>");
	print("  - CODIGO: " . $e->getCode());print("\n<br/>");
	print("  - MENSAJE: " . $e->getMessage());print("\n<br/>");

	var_dump($e);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print($e->getTraceAsString());print("\n<br/>");
	print('<pre>');
	print('<pre>');
	$vDebugInfo = $clienteWS->getDebugInfo();
	print_r($vDebugInfo);
	print($e->getMessage());
	print('</pre>');
}

?>