<?php

use WSCOMUN\WSComunFClient;

//error_reporting(E_ERROR | E_WARNING | E_PARSE);
error_reporting(E_ALL);
ini_set('display_errors', 1);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../../include/WSComunFClient.php';

$keyRD 		= WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL;


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyRD => 'https://innovacion-pre.gva.es/pai_bus_inno/RD/RegistroDepartamentalService_v1_00?wsdl'
);


$vTrazabilidad = array
(
		'idApp'=>	'WSCOMUN'			//WSCOMUN
);


// Parametros de la consulta
$codDep = '02ORVE1/2017/184/S';
$fechaStr = '20180220150748';
$devolverDocumentos = true;

try
{
	// Creacin del cliente
	set_time_limit(40);
	$clienteWS = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL, $v_wsdl, $vTrazabilidad);
	$clienteWS->setDebugMode(true);

	// Consulta al WS
	$oRespWS = $clienteWS->consultaRegistroDepartamental($codDep, $fechaStr, $devolverDocumentos);

//	echo('<pre>');print_r($oRespWS);echo('</pre>');die;

	// Muestra los resultados
	$oDatReg = $oRespWS->getDatosRegistroDepartamental();
	$codigoRegistro = $oDatReg->getCodigoOrganismoUnidadDepartamental() .
			$oDatReg->getCodigoUnidadDepartamental() . '/' .
			$oDatReg->getAnyo() . '/' .
			$oDatReg->getNumeroRegistro() . '/' .
			$oDatReg->getTipoRegistroDepartamental();

	echo("Resultado: " . $oRespWS->getResultado() . "<br>\r\n");
	echo("Reg.Departamental: " . $codigoRegistro . " | " . $oDatReg->getFechaRegistro() . "<br>\r\n");
	echo("Estado: " . $oDatReg->getEstado() . "<br>\r\n");
	echo("Anulado: " . ($oDatReg->getAnulado() ? "SI" : "NO") . "<br>\r\n");
	echo("Asunto: " . $oDatReg->getAsunto() . "<br>\r\n");

	// Muestra los documentos
	echo("Documentos: <br>\r\n");
	if ($oDatReg->hasDocumentos()) {
		$oDocs = $oDatReg->getDocumentos();
		if ($oDocs->hasDocumento()) {
			for ($iDoc=0; $iDoc < $oDocs->countDocumento(); $iDoc++) {
				$oDoc = $oDocs->getDocumento($iDoc);

				$nombre = $oDoc->getNombreDocumento();
				$desc = $oDoc->getDescripcionDocumento();

				echo "&nbsp;- $nombre: $desc<br>\r\n";
			}
		}
	}

	echo("<br>\r\n\r\n");

	echo('<pre>');print_r($oRespWS);echo('</pre>');die;

}
catch (\WSCOMUN\WSComunPAIException $e)
{
	print("\n<br/>Excepcion PAI: \n<br/>");
	print("  - ERROR: " . $e);print("\n<br/>");
	print("  - CODIGO: " . $e->getCode());print("\n<br/>");
	print("  - MENSAJE: " . $e->getMessage());print("\n<br/>");

	var_dump($e);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = $clienteWS->getDebugInfo();
	print_r($vDebugInfo);
	print('</pre>');
}


?>
