<?php

use WSCOMUN\WSComunFClient;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyPF 		= WSComunFClient::KEYCLIENTE_PF;
$keyPFMOD	= WSComunFClient::KEYCLIENTE_PF_MOD;
$keyPFADM	= WSComunFClient::KEYCLIENTE_PF_ADM;

require_once 'libOpts.php';


/*
 * El script muestra listados de los elementos contenidos en el portafirmas.
 *
 * Las funciones aceptan como filtro un valor de bsqueda o null, si se quiere listar todos los elementos disponibles.
 * La funcin 'queryUsers' acepta carcteres comodn del estilo de '%'
 *
 * Incluye llamadas a todas funciones del servicio de consulta, excepto las relativas a la gestin de peticiones y documentos
 * 	- downloadDocument
 * 	- downloadSign
 * 	- querySign
 */


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
	$keyPF			=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/QueryService_v2_00?wsdl',
	$keyPFMOD		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/ModifyService_v2_00?wsdl',
	$keyPFADM		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/AdminService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


$username = 'WSCOMUN';
$password = 'WSC4M5N';

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_PF, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);

	$queryNull = null;	// Muchas solicitudes devuelven todos los elementos al recibir null como filtro de busqueda

	// pf_queryUsers
	$query = '%WSCOMUN%';	// null or % -> muestran todos;
	$respuesta = $clienteSIRCA->pf_queryUsers($username, $password, $query);
	print("<br>\nListado de usuarios con el patron $query:<br>\n");
	foreach ($respuesta['userList']['user'] as $vItem) {
		$nombreCompleto = $vItem['name'];
		if (isset($vItem['surname1'])) {
			$nombreCompleto .= ' ' . $vItem['surname1'];
		}
		if (isset($vItem['surname2'])) {
			$nombreCompleto .= ' ' . $vItem['surname2'];
		}

		print("- Id: {$vItem['identifier']}, Name: $nombreCompleto<br>\n");
	}
	//print_r($respuesta);



	// pf_queryJobs
	$respuesta = $clienteSIRCA->pf_queryJobs($username, $password, $queryNull);
	print("<br>\nListado de Jobs:<br>\n");
	foreach ($respuesta['jobList']['job'] as $vItem) {
		print("- Id: {$vItem['identifier']}, Description: {$vItem['description']}<br>\n");
	}
	//print_r($respuesta);



	// pf_queryStates
	$respuesta = $clienteSIRCA->pf_queryStates($username, $password, $queryNull);
	print("<br>\nListado de States:<br>\n");
	foreach ($respuesta['stateList']['state'] as $vItem) {
		print("- Id: {$vItem['identifier']}<br>\n");
	}
	//print_r($respuesta);



	// pf_querySeats
	$respuesta = $clienteSIRCA->pf_querySeats($username, $password, $queryNull);
	print("<br>\nListado completo de sedes:<br>\n");
	foreach ($respuesta['seatList']['seat'] as $vItem) {
		print("- Code: {$vItem['code']}, Description: {$vItem['description']}<br>\n");
	}
	//print_r($respuesta);


	// pf_queryDocumentTypes
	$respuesta = $clienteSIRCA->pf_queryDocumentTypes($username, $password, $queryNull);
	print("<br>\nListado completo de tipos de documentos:<br>\n");
	foreach ($respuesta['documentTypeList']['documentType'] as $vItem) {
		print("- Id: {$vItem['identifier']}, Description: {$vItem['description']}, valid: {$vItem['valid']}<br>\n");
	}
	//print_r($respuesta);



	// pf_queryImportanceLevels
	$respuesta = $clienteSIRCA->pf_queryImportanceLevels($username, $password, $queryNull);
	print("<br>\nListado completo de ImportanceLevels:<br>\n");
	foreach ($respuesta['importanceLevelList']['importanceLevels'] as $vImpLevel) {
		print("- LevelCode: {$vImpLevel['levelCode']}, Description: {$vImpLevel['description']}<br>\n");
	}
	//print_r($respuesta);



	// pf_queryEnhancedJobs
	$respuesta = $clienteSIRCA->pf_queryEnhancedJobs($username, $password, $queryNull, $queryNull);
	print("<br>\nListado completo de EnhancedJobs:<br>\n");
	foreach ($respuesta['enhancedJobList']['enhancedJob'] as $vEnhanceJob) {
		print("- [Job] Id: {$vEnhanceJob['job']['identifier']}, Description: {$vEnhanceJob['job']['description']}<br>\n");
		print("--- [enhancedUserJobInfo] Sede: {$vEnhanceJob['enhancedUserJobInfo']['seat']['code']}/{$vEnhanceJob['enhancedUserJobInfo']['seat']['description']}, valid: {$vEnhanceJob['enhancedUserJobInfo']['valid']}, visibleOtherSeats: {$vEnhanceJob['enhancedUserJobInfo']['visibleOtherSeats']}<br>\n");
	}
	//print_r($respuesta);


	// pf_queryEnhancedUserJobAssociatedToJob
	$respuesta = $clienteSIRCA->pf_queryEnhancedUserJobAssociatedToJob($username, $password, $queryNull);
	print("<br>\nListado completo de EnhancedUserJobAssociatedToJob:<br>\n");
	if (empty($respuesta['enhancedUserJobAssociatedList'])) {
		print("- &lt;VACIO&gt;<br>\n");
	} else {
		foreach ($respuesta['enhancedUserJobAssociatedList'] as $vEnhanced) {
			print_r($vEnhanced);die;
			print("- [User] Id: {$vEnhanced['user']['identifier']}<br>\n");
			print("--- [UserInfo] Id: {$vEnhanced['user']['identifier']} [{$vEnhanced['user']['name']} {$vEnhanced['user']['surname1']}]<br>\n");
			print("--- [job] id: {$vEnhanced['enhancedJob']['seat']['code']}/{$vEnhanced['enhancedUserJobInfo']['seat']['description']}, valid: {$vEnhanced['enhancedUserJobInfo']['valid']}, visibleOtherSeats: {$vEnhanced['enhancedUserJobInfo']['visibleOtherSeats']}<br>\n");
			print("--- [enhancedUserJobInfo] Sede: {$vEnhanced['enhancedUserJobInfo']['seat']['code']}/{$vEnhanced['enhancedUserJobInfo']['seat']['description']}, valid: {$vEnhanced['enhancedUserJobInfo']['valid']}, visibleOtherSeats: {$vEnhanced['enhancedUserJobInfo']['visibleOtherSeats']}<br>\n");
		}
	}
	//print_r($respuesta);


	// pf_queryEnhancedUserJobAssociatedToUser
	$respuesta = $clienteSIRCA->pf_queryEnhancedUserJobAssociatedToUser($username, $password, 'WSCOMUN');
	print("<br>\nListado completo de EnhancedUserJobAssociatedToUser:<br>\n");
	if (empty($respuesta['enhancedUserJobAssociatedList'])) {
		print("- &lt;VACIO&gt;<br>\n");
	} else {
		foreach ($respuesta['enhancedUserJobAssociatedList']['xxx'] as $vEnhanceJob) {
			print("- XXX<br>\n");
			//print("- [Job] Id: {$vEnhanceJob['job']['identifier']}, Description: {$vEnhanceJob['job']['description']}<br>\n");
			//print("--- [enhancedUserJobInfo] Sede: {$vEnhanceJob['enhancedUserJobInfo']['seat']['code']}/{$vEnhanceJob['enhancedUserJobInfo']['seat']['description']}, valid: {$vEnhanceJob['enhancedUserJobInfo']['valid']}, visibleOtherSeats: {$vEnhanceJob['enhancedUserJobInfo']['visibleOtherSeats']}<br>\n");
		}
	}
	//print_r($respuesta);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>